<?php
require_once('../config.php'); 
session_start();
if(!isset($_SESSION['login_user_id']) || time() - $_SESSION['login_time'] > 86400 || !isset($_SESSION['login_type'])){
	header("location: ../login.php");
	die();
}else{
	$_SESSION['login_time'] = time();
}
function fnGetClients($conn){
	$sql = "Select id As client_id, name As client_name from timesheet.clients";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('clients'=> $json_array);
}

function fnGetProjects($conn){
	$sql = "Select client_id, a.id project_id, project_name, a.from_date, a.to_date, status, sum(b.total_effort) total_effort From timesheet.projects a Left Outer Join timesheet.subtask b On a.id = b.project_id where status !='deleted' Group by a.id";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('projects'=> $json_array);
}

function fnGetSubTask($conn){
	$sql = "Select project_id, a.id subtask_id, subtask_name, billable, total_effort, COALESCE(sum(b.entry_hours), 0)/24 utilized_effort, from_date, to_date, client_approved, payment_received From timesheet.subtask a Left Outer Join timesheet.timeentry b on a.id = b.subtask_id Group By a.id";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('subtasks'=> $json_array);
}

function fnGetMappedEmployees($conn){
	$sql = "Select subtask_id, activity_id, employee_id, name from timesheet.employee_subtask_mapping a, timesheet.employees b Where a.employee_id = b.id order by 1, 2";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('employees_mapped'=> $json_array);
}

function fnGetActivities($conn){
	$sql = "Select id activity_id, name from timesheet.activities";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('activities'=> $json_array);
}

function fnGetEmployees($conn){
	$sql = "Select id employee_id, name, username,password,login_type,status from timesheet.employees where status='active'";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	// echo "<pre>";print_r($json_array);exit;
	return array('employees'=> $json_array);
}

function fnGet($conn){
	//echo "Inside fnGet: ".date("Y-m-d H:i:s")."\n";
	//$localJSONData = json_decode(file_get_contents("ost_report.json"), true);

	//Get clients and staff data from DB
	$clientList = fnGetClients($conn);
	//echo "Time took to execute fnGetClients: ".date("Y-m-d H:i:s")."\n";
	$projectList = fnGetProjects($conn);
	//echo "Time took to execute fnGetProjects: ".date("Y-m-d H:i:s")."\n";
	$subTasktList = fnGetSubTask($conn);
	//echo "Time took to execute fnGetSubTask: ".date("Y-m-d H:i:s")."\n";
	$empMaptList = fnGetMappedEmployees($conn);
	//echo "Time took to execute fnGetMappedEmployees: ".date("Y-m-d H:i:s")."\n";
	$activityList = fnGetActivities($conn);
	//echo "Time took to execute fnGetActivities: ".date("Y-m-d H:i:s")."\n";
	$empList = fnGetEmployees($conn);
	//echo "Time took to execute fnGetEmployees: ".date("Y-m-d H:i:s")."\n";
	$finalResMsg = json_encode(array_merge(array_merge(array_merge(array_merge(array_merge($clientList, $projectList), $subTasktList), $empMaptList), $activityList), $empList));
	//echo "Time took to merge all arrays: ".date("Y-m-d H:i:s")."\n";
	//echo "Eit from fnGet: ".date("Y-m-d H:i:s")."\n";
	return  $finalResMsg;

}

function fnNewProject($reqMsg, $conn){
	//echo "Inside new project";
	$sql = "Insert Into timesheet.projects (client_id, project_name, from_date, to_date, status) Values(".$reqMsg->client_id.",'".$reqMsg->project_name."','".$reqMsg->from_date."','".$reqMsg->to_date."','".$reqMsg->status."')";
	if ($conn->query($sql) === TRUE) {
		//echo "New project created successfully";
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnNewClient($reqMsg, $conn){
	$sql = "Insert Into timesheet.clients (name) Values('".$reqMsg->client_name."')";
	if ($conn->query($sql) === TRUE) {
		
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnEditClient($reqMsg, $conn){
	$sql = "Update timesheet.clients SET name = '".$reqMsg->client_name."' Where id = '".$reqMsg->client_id."'";
	if ($conn->query($sql) === TRUE) {
		
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnNewActivity($reqMsg, $conn){
	$sql = "Insert Into timesheet.activities (name) Values('".$reqMsg->activity_name."')";
	if ($conn->query($sql) === TRUE) {
		
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnEditActivity($reqMsg, $conn){
	$sql = "Update timesheet.activities SET name = '".$reqMsg->activity_name."' Where id = '".$reqMsg->activity_id."'";
	if ($conn->query($sql) === TRUE) {
		
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function rand_string( $length ) {
	$chars = "abcdefghijklmnopqrstuvwxyz0123456789";
	return substr(str_shuffle($chars),0,$length);	
}

function fnNewEmployee($reqMsg, $conn){
	$username = $password = '';
	if($reqMsg->employee_name){
		$username = strtolower(str_replace(' ', '.', $reqMsg->employee_name));
		$login_type = strtolower(str_replace(' ', '.', $reqMsg->login_type));
		$status = strtolower(str_replace(' ', '.', $reqMsg->status));
		$password = rand_string(7);
	}
	$sql = "Insert Into timesheet.employees (name,username,password,login_type,status) Values('".$reqMsg->employee_name."','".$username."','".$password."','".$login_type."','".$status."')";
	if ($conn->query($sql) === TRUE) {
		
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnEditEmployee($reqMsg, $conn){
	$sql = "Update timesheet.employees SET name = '".$reqMsg->employee_name."', login_type='".$reqMsg->login_type."', status='".$reqMsg->status."' Where id = '".$reqMsg->employee_id."'";
	if ($conn->query($sql) === TRUE) {
		
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}


function fnUpdateSubTaskEmpMapping($conn, $subTaskID, $activityArray){
	//echo "Inside fnUpdateSubTaskEmpMapping: ".date("Y-m-d H:i:s")."\n";
	$sql = "Delete From timesheet.employee_subtask_mapping Where subtask_id = ".$subTaskID;
	$conn->query($sql);
	$sql_insert = "Insert Into timesheet.employee_subtask_mapping(subtask_id, activity_id, employee_id) Values ";
	$sql_values = null;
	$sql = null;
	//echo "After deleting timesheet.employee_subtask_mapping: ".date("Y-m-d H:i:s")."\n";
	if(count($activityArray) > 0){
		foreach($activityArray as $eachActivity) {
			$activity_id = $eachActivity->activity_id;
			if(count($eachActivity->employees)>0){
				foreach($eachActivity->employees as $eachEmployee) {
					//$sql .= "Insert Into timesheet.employee_subtask_mapping(subtask_id, activity_id, employee_id) Values(".$subTaskID.",".$activity_id.",".$eachEmployee->emp_id.");";
					$sql_values .= "(".$subTaskID.",".$activity_id.",".$eachEmployee->emp_id."),";
				}
			}
		}
		if($sql_values != null){
			$sql_values = rtrim($sql_values,',');
			$sql = $sql_insert . $sql_values;
			//echo "\n";
			//echo "Sql for insert activity cahnge ". $sql;
			//echo "\n";
			$conn->query($sql);
		}
	}
	//echo "Exiting from fnUpdateSubTaskEmpMapping: ".date("Y-m-d H:i:s")."\n";
}

function fnNewSubTask($reqMsg, $conn){
	//echo "Inside fnNewSubTask";
	$sql = "Insert Into timesheet.subtask (project_id, subtask_name, from_date, to_date, billable, total_effort, client_approved, payment_received) Values(".$reqMsg->project_id.",'".$reqMsg->subtask_name."','".$reqMsg->from_date."','".$reqMsg->to_date."','".$reqMsg->billable."',".$reqMsg->total_effort.",'".$reqMsg->client_approved."','".$reqMsg->payment_received."')";
	if ($conn->query($sql) === TRUE) {
		$subTaskID = $conn->insert_id;
		//echo "New subtask created successfully with ID ".$subTaskID;
		$activities = $reqMsg->activities;
		fnUpdateSubTaskEmpMapping($conn, $subTaskID, $reqMsg->activities);
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnEditProject($reqMsg, $conn){
	//echo "Inside new project";
	$sql = "Update timesheet.projects Set client_id=".$reqMsg->client_id.",project_name='".$reqMsg->project_name."',from_date='".$reqMsg->from_date."',to_date='".$reqMsg->to_date."',status='".$reqMsg->status."' Where id = ".$reqMsg->project_id.";";
	if ($conn->query($sql) === TRUE) {
		//echo "Project edited successfully";
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnEditSubTask($reqMsg, $conn){
	//echo "Inside fnEditSubTask: ".date("Y-m-d H:i:s")."\n";
	$sql = "Update timesheet.subtask Set subtask_name='".$reqMsg->subtask_name."',from_date='".$reqMsg->from_date."',to_date='".$reqMsg->to_date."',billable='".$reqMsg->billable."',total_effort=".$reqMsg->total_effort.", client_approved='".$reqMsg->client_approved."',payment_received='".$reqMsg->payment_received."' Where id = ".$reqMsg->subtask_id.";";
	if ($conn->query($sql) === TRUE) {
		//echo "After update of timesheet.subtask: ".date("Y-m-d H:i:s")."\n";
		//echo "Subtask edited successfully";
		$activities = $reqMsg->activities;
		fnUpdateSubTaskEmpMapping($conn, $reqMsg->subtask_id, $reqMsg->activities);
		//echo "After delete and insert of timesheet.employee_subtask_mapping: ".date("Y-m-d H:i:s")."\n";
	} else {
		echo "Error: " . $sql . "<br>" . $conn->error;
	}
}

function fnPost($conn){
	//echo "Inside fnPost: ".date("Y-m-d H:i:s")."\n";
	
	$requestData = json_decode(file_get_contents('php://input'));
	//echo "After reading local json file: ".date("Y-m-d H:i:s")."\n";
	
	$serviceName = $requestData->service;
	if($serviceName === 'new_project'){
		fnNewProject($requestData, $conn);
		//echo "After fnNewProject call: ".date("Y-m-d H:i:s")."\n";
	}else if($serviceName === 'edit_project'){
		fnEditProject($requestData, $conn);
		//echo "After fnEditProject call: ".date("Y-m-d H:i:s")."\n";
	}else if($serviceName === 'new_subtask'){
		fnNewSubTask($requestData, $conn);
		//echo "After fnNewSubTask call: ".date("Y-m-d H:i:s")."\n";
	}else if($serviceName === 'edit_subtask'){
		fnEditSubTask($requestData, $conn);
		//echo "After fnEditSubTask call: ".date("Y-m-d H:i:s")."\n";
	}else if($serviceName === 'new_client'){
		fnNewClient($requestData, $conn);
	}else if($serviceName === 'edit_client'){
		fnEditClient($requestData, $conn);
	}else if($serviceName === 'new_activity'){
		fnNewActivity($requestData, $conn);
	}else if($serviceName === 'edit_activity'){
		fnEditActivity($requestData, $conn);
	}else if($serviceName === 'new_employee'){
		fnNewEmployee($requestData, $conn);
	}else if($serviceName === 'edit_employee'){
		fnEditEmployee($requestData, $conn);
	}
	//echo "Before calling fnGet: ".date("Y-m-d H:i:s")."\n";
	$resMsg = fnGet($conn);
	//echo "After calling fnGet: ".date("Y-m-d H:i:s")."\n";

	
	$resMsg = json_decode($resMsg, true);
	$resMsg['result'] = "SUCCESS";
	$resMsg['message'] = "Successfully Saved.";
	$resMsg = json_encode($resMsg);
	echo $resMsg;
	//$resMsg->result = 'SUCCESS';
	//array_push($resMsg,["jaison"]);
	//echo $resMsg;
}

If($_SERVER['REQUEST_METHOD'] === 'GET'){
	$conn = fnGetConnection();
	if(isset($_GET['start_week']) && !empty($_GET['start_week']))
	{
		getMissedEntry($conn,$_GET['start_week']);
	}
	$resMsg = fnGet($conn);
	mysqli_close($conn);
}

If($_SERVER['REQUEST_METHOD'] === 'POST'){
	//echo "First line in POST: ".date("Y-m-d H:i:s")."\n";
	header("Content-Type: application/json");
	//echo "Getting connection: ".date("Y-m-d H:i:s")."\n";
	$conn = fnGetConnection();
	//$conn->query("START TRANSACTION");
	//echo "Calling fnPost: ".date("Y-m-d H:i:s")."\n";
	fnPost($conn);
	//echo "After fnPost: ".date("Y-m-d H:i:s")."\n";
	//$conn->query("COMMIT");
	mysqli_close($conn);
	//echo "After connection close: ".date("Y-m-d H:i:s")."\n";
	exit();
}


?>

<html>
	<head>
		<link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">
		<link rel="stylesheet" href="../timesheet_v4.css">
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
		<title>Dvara Timesheet - Admin</title>
	</head>
	<body onload="fnPageLoadAdmin()">
		<div id='client_div' style="width:99%; text-align: center;">
			<span>
				<label for='ts__clientlist'>Client Name: </label>
				<select id='ts__clientlist' onchange='fnChangeClient(this)'>
				</select>
			</span>	
			<span style="float:right;">
			<a href="../logout.php"><input type="button" value="Logout"></a>		
			</span>
			<span style="float:right;">
			<a href="../timeentry/timeentry.php"><input type="button" value="Time Entry"></a>		
			</span>
			<span style="float:right;">
			<a href="timesheet_report.php"><input type="button" value="Reports"></a>		
			</span>
			<span style="float:right;">
			<a href="timesheet_masters.php"><input type="button" value="Masters"></a>		
			</span>
			
		</div>
		
		<div id='project_div_main' style="width:99%;">
			<div class="flex-container" style="margin-top: 5px; margin-bottom: 10px;">
				<div><span>Projects:</span></div>
				&nbsp;&nbsp;&nbsp;&nbsp;
				<div><a href="javascript:void(0);" onclick="return fnShowPopup('new_project_div', 'new_project');"><i class="fa fa-plus"></i></a></div>
			</div>
			<div id='project_div' style="display: none; text-align: center;">
				
			</div>
		</div>
		<div id='subtask_div_main' style="width:99%;">
			<div class="flex-container" style="margin-top: 5px; margin-bottom: 10px;">
				<div><span>Sub-Tasks:</span></div>
				&nbsp;&nbsp;&nbsp;&nbsp;
				<div><a href="javascript:void(0);" onclick="return fnShowPopup('new_subtask_div', 'new_subtask');"><i class="fa fa-plus"></i></a></div>
			</div>
			<div id='subtask_div' style="display: none; text-align: center;">
				
			</div>
		</div>

		
		<br>
		<div id='new_project_div' style="display: none;" class="modal">
			<!-- Modal content -->
			<div class="modal-content">
				<span class="close" onclick="return fnCloseModal('new_project_div');">&times;</span>
				<br>
				<div style="text-align: center;">
					<label>Project Name:</label>
					<input type="text" name="project__projectname" id="project__projectname" size="70">
				</div>
				<br>
				<div style="width: 100%">
					<div style="width: 45%; float: left;">
						<label>From Date:</label>
						<input type="date" name="project__fromdate" id="project__fromdate">
					</div>
					<div style="width: 45%; float: right;">
						<label>To Date:</label>
						<input type="date" name="project__todate" id="project__todate">
					</div>
				</div>
				<br>
				<br>
				<label>Satus:</label>
				<select id="project__active">
					<option value="active">Active</option>
					<option value="inactive">Inactive</option>
					<option value="deleted">Deleted</option>
				</select>
				<br>
				<br>
				<div style="text-align:right;">
					<input type="button" value="Save Project" onclick="fnSaveProject()">
				</div>
			</div>
		</div>

		<div id='new_subtask_div' style="display: none;" class="modal">
			<!-- Modal content -->
			<div class="modal-content">
				<span class="close" onclick="return fnCloseModal('new_subtask_div');">&times;</span>
				<div style="text-align: center;">
					<br>
					<label><b>Sub-Task Name:</b></label>
					<input type="text" name="subtask__subtaskname" id="subtask__subtaskname" size="70">
				</div>
				<br>
				<div style="width: 100%">
					<div style="width: 45%; float: left;">
						<label>From Date:</label>
						<input type="date" name="subtask__fromdate" id="subtask__fromdate">
					</div>
					<div style="width: 45%; float: right;">
						<label>To Date:</label>
						<input type="date" name="subtask__todate" id="subtask__todate">
					</div>
				</div>
				<br>
				<br>
				<div>
					<div style="width: 45%; float: left;">
						<label>Billable?</label>
						<select id="subtask__billable">
							<option value="N">No</option>
							<option value="Y">Yes</option>
						</select>
					</div>
					<div style="width: 45%; float: right;">
						<label>Total Effort:</label>
						<input type="text" name="subtask__totaleffort" id="subtask__totaleffort">
					</div>
				</div>
				<br>
				<br>
				<div>
					<div style="width: 45%; float: left;">
						<label>Client Approved?</label>
						<select id="subtask__clientapproved">
							<option value="N">No</option>
							<option value="Y">Yes</option>
						</select>
					</div>
					<div style="width: 45%; float: right;">
						<label>Payment Received?:</label>
						<select id="subtask__paymentreceived">
							<option value="N">No</option>
							<option value="Y">Yes</option>
						</select>
					</div>
				</div>
				<br>
				<br>
				<div style="display:none;width: 100%;">
					<div id="search_employee" style="float: left; width: 50%;">
						<label>Employee Mapping:</label>
						<input type='list' list="employees_dl" onchange='fnOnEmployeeSelection(this)' placeholder="Type Employee name" />
						<datalist id='employees_dl'>
						</datalist>
					</div>
					<div id='emp_list_div' class='emp_list_div1' style="float: right; width: 50%;">
					</div>
				</div>
				<br>
				<br>
				<br>
				<br>
				<hr>
				<div id='subtask_activities_div'>
				</div>
				<br>
				<div style="text-align:right;">
					<input type="button" value="Save Sub-Task" onclick="fnSaveSubtask()">
				</div>
			</div>
		</div>
	</body>
</html>
<script type="text/javascript" src="../timesheet_v4.js"></script>
<script type="text/javascript">
	var getResMsg = <?php echo json_encode($resMsg) ?>;
	//localStorage.setItem("ts_localstorage", getResMsg);
	localStorage.setItem("ts_admin_localstorage", getResMsg);
	//google.charts.load('current', {packages: ['corechart']});
	//google.charts.setOnLoadCallback(drawChart);
</script>
