create database timesheet;

Drop TABLE timesheet.clients;
CREATE TABLE timesheet.clients (
  id int NOT NULL AUTO_INCREMENT,
  name varchar(60) NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY client_name (name)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

Select * From clients;
Insert Into timesheet.clients (name) Values('Kinara');
Insert Into timesheet.clients (name) Values('KGFS');
Insert Into timesheet.clients (name) Values('Witfin');
Insert Into timesheet.clients (name) Values('Maitreya');
Insert Into timesheet.clients (name) Values('Pahal');
Insert Into timesheet.clients (name) Values('Arohan');
Insert Into timesheet.clients (name) Values('IREP-Dhan');
Insert Into timesheet.clients (name) Values('Sambandh');


Drop TABLE timesheet.projects;
CREATE TABLE timesheet.projects (
  id int NOT NULL AUTO_INCREMENT,
  client_id int NOT NULL,
  project_name varchar(100) NOT NULL,
  from_date date,
  to_date date,
  active varchar(1) NOT NULL Default 'Y',
  PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

Select * From timesheet.projects;
Insert Into timesheet.projects (client_id, project_name, from_date, to_date) values(1, 'KGF-MAY19', '2019-05-01', '2019-05-30');
Insert Into timesheet.projects (client_id, project_name, from_date, to_date) values(1, 'KGF-JUN19', '2019-06-01', '2019-06-30');
Insert Into timesheet.projects (client_id, project_name, from_date, to_date) values(2, 'KIN-MAY19', '2019-05-01', '2019-05-30');


Drop TABLE timesheet.subtask;
CREATE TABLE timesheet.subtask (
  id int NOT NULL AUTO_INCREMENT,
  project_id int NOT NULL,
  subtask_name varchar(200) NOT NULL,
  from_date date,
  to_date date,
  billable varchar(1) NOT NULL Default 'N',
  total_effort int,
  client_approved varchar(1) Not Null Default 'N',
  payment_received varchar(1) Not Null Default 'N',
  PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

Select * From timesheet.subtask;
Insert Into timesheet.subtask (project_id, subtask_name, from_date, to_date, billable, total_effort, utilized_effort) values(1, 'Mantra Integration', '2019-05-01', '2019-05-30', 'N', 100, 20);
Insert Into timesheet.subtask (project_id, subtask_name, from_date, to_date, billable, total_effort, utilized_effort) values(1, 'MEL Changes', '2019-05-01', '2019-05-30', 'Y', 100, 60);
Insert Into timesheet.subtask (project_id, subtask_name, from_date, to_date, billable, total_effort, utilized_effort) values(2, 'Test', '2019-05-01', '2019-05-30', 'Y', 50, 20);
Insert Into timesheet.subtask (project_id, subtask_name, from_date, to_date, billable, total_effort, utilized_effort) values(3, 'Test - Kinara', '2019-05-01', '2019-05-30', 'Y', 50, 20);
Insert Into timesheet.subtask (project_id, subtask_name, from_date, to_date, billable, total_effort, utilized_effort) values(3, 'Test2 - Kinara 2', '2019-05-01', '2019-05-30', 'Y', 50, 20);


Drop TABLE timesheet.activities;
Create Table timesheet.activities(
id int NOT NULL AUTO_INCREMENT,
name Varchar(100) Not Null,
PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

Select * from timesheet.activities;
Insert Into timesheet.activities(name) Values('CUT');
Insert Into timesheet.activities(name) Values('Testing');
Insert Into timesheet.activities(name) Values('Production Support');
Insert Into timesheet.activities(name) Values('Consulting');


Drop TABLE timesheet.employees;
Create Table timesheet.employees(
id int NOT NULL AUTO_INCREMENT,
username Varchar(20) Not Null,
name Varchar(100) Not Null,
password Varchar(10) Not Null,
PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

Select * from timesheet.employees;
Insert Into timesheet.employees (name)Values('Jaison Jacob');
Insert Into timesheet.employees (name)Values('Manisha Jha');
Insert Into timesheet.employees (name)Values('Karthik D');
Insert Into timesheet.employees (name)Values('Neminath');
Insert Into timesheet.employees (name)Values('Arun');
Insert Into timesheet.employees (name)Values('Varun');

Drop TABLE timesheet.employee_subtask_mapping;
Create Table timesheet.employee_subtask_mapping(
id int NOT NULL AUTO_INCREMENT,
subtask_id int NOT NULL,
activity_id int NOT NULL,
employee_id int NOT NULL,
PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
Create Index subtask_id_indx on timesheet.employee_subtask_mapping(subtask_id);
Create Index employee_id_indx on timesheet.employee_subtask_mapping(employee_id);

Select * from timesheet.employee_subtask_mapping;


Drop TABLE timesheet.timeentry;
Create Table timesheet.timeentry(
id int NOT NULL AUTO_INCREMENT,
subtask_id int NOT NULL,
activity_id int NOT NULL,
employee_id int NOT NULL,
entry_date Date not null,
entry_hours int not null,
week_start Date not null,
PRIMARY KEY (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



===============================================================================================

Select f.name client, e.project_name, d.subtask_name, c.name activityName, b.name empName, d.from_date, d.to_date, a.employee_id, a.activity_id, a.subtask_id
From employee_subtask_mapping a, employees b, activities c, subtask d, projects e, clients f
Where a.employee_id = b.id
And a.activity_id = c.id
And a.subtask_id = d.id
And d.project_id = e.id
And e.client_id = f.id
And e.active = 'Y'
;





Insert Into timesheet.employees (name) Values('Abdul Najam');
Insert Into timesheet.employees (name) Values('Akshat Agarwal');
Insert Into timesheet.employees (name) Values('Akshay Yadav');
Insert Into timesheet.employees (name) Values('Amit Shah');
Insert Into timesheet.employees (name) Values('Arabind Achary');
Insert Into timesheet.employees (name) Values('Arunkashyap G l');
Insert Into timesheet.employees (name) Values('Ashwin Kumar');
Insert Into timesheet.employees (name) Values('Basim MK');
Insert Into timesheet.employees (name) Values('Bibhuti Kumar');
Insert Into timesheet.employees (name) Values('Cas Support');
Insert Into timesheet.employees (name) Values('Hareesh Menon');
Insert Into timesheet.employees (name) Values('Harish D');
Insert Into timesheet.employees (name) Values('Hemanth Kumar');
Insert Into timesheet.employees (name) Values('Jaison Jacob');
Insert Into timesheet.employees (name) Values('Karthik Devadiga');
Insert Into timesheet.employees (name) Values('Karthikeyan V');
Insert Into timesheet.employees (name) Values('Kaustuv Majumder');
Insert Into timesheet.employees (name) Values('Kumar Abhishek');
Insert Into timesheet.employees (name) Values('Lakshmipriya PS');
Insert Into timesheet.employees (name) Values('Madhusudhanan S');
Insert Into timesheet.employees (name) Values('Mallika Gollapalli');
Insert Into timesheet.employees (name) Values('Manisha Jha');
Insert Into timesheet.employees (name) Values('Manjunath V A');
Insert Into timesheet.employees (name) Values('Manoranjan Das');
Insert Into timesheet.employees (name) Values('Maria Ruban');
Insert Into timesheet.employees (name) Values('Nagamani Mandava');
Insert Into timesheet.employees (name) Values('Namita Sivasankaran');
Insert Into timesheet.employees (name) Values('Neha yogesh');
Insert Into timesheet.employees (name) Values('neminath patil');
Insert Into timesheet.employees (name) Values('Nisha  Admane');
Insert Into timesheet.employees (name) Values('Onkar Nath');
Insert Into timesheet.employees (name) Values('Prabha R');
Insert Into timesheet.employees (name) Values('Pradeep Kumar');
Insert Into timesheet.employees (name) Values('Prakash D');
Insert Into timesheet.employees (name) Values('Prakash. Bariya');
Insert Into timesheet.employees (name) Values('Praveen kumar');
Insert Into timesheet.employees (name) Values('Praveen Kumar HT');
Insert Into timesheet.employees (name) Values('preethi magesh');
Insert Into timesheet.employees (name) Values('Rahul R');
Insert Into timesheet.employees (name) Values('Rajesh Kumar');
Insert Into timesheet.employees (name) Values('Randhir D');
Insert Into timesheet.employees (name) Values('Ranjit Kumar');
Insert Into timesheet.employees (name) Values('Raveena Sindhu');
Insert Into timesheet.employees (name) Values('Sandip Jena');
Insert Into timesheet.employees (name) Values('Sangeeth B');
Insert Into timesheet.employees (name) Values('Sanjana Bhati');
Insert Into timesheet.employees (name) Values('Sasikala B');
Insert Into timesheet.employees (name) Values('Satyajit Sahu');
Insert Into timesheet.employees (name) Values('SenSei Support');
Insert Into timesheet.employees (name) Values('Shahal Tharique');
Insert Into timesheet.employees (name) Values('Srishti Goel');
Insert Into timesheet.employees (name) Values('Stalin Solomon');
Insert Into timesheet.employees (name) Values('Sunil Kumar');
Insert Into timesheet.employees (name) Values('varun hv');
Insert Into timesheet.employees (name) Values('Venkatesh M');
Insert Into timesheet.employees (name) Values('vidyalakshmi Shet');
Insert Into timesheet.employees (name) Values('Vijay Bharani');
Insert Into timesheet.employees (name) Values('Yashavanth  Kumar');