<?php
require_once('../config.php'); 
session_start();
if(!isset($_SESSION['login_user_id']) || time() - $_SESSION['login_time'] > 86400){
	header("location:../login.php");
	die();
}else{
	$_SESSION['login_time'] = time();
}

function fnGetEmployees($conn){
	$sql = "Select id employee_id, name from timesheet.employees";
	$result = $conn->query($sql) or die("cannot write");
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('employees'=> $json_array);
}

function fnGetEmpMappedProjectForEntry($conn){
	$sql = "Select f.name client, e.project_name, d.subtask_name, c.name activity_name, b.name empName, d.from_date, d.to_date, a.employee_id, a.activity_id, a.subtask_id, group_concat(ConCat(ConCat(x.entry_date, '|'), x.entry_hours) Order By x.entry_date) saved_entries From timesheet.employee_subtask_mapping a Left Outer Join timesheet.timeentry x on a.subtask_id = x.subtask_id and a.activity_id = x.activity_id and a.employee_id = x.employee_id, timesheet.employees b, timesheet.activities c, timesheet.subtask d, timesheet.projects e, timesheet.clients f  Where a.employee_id = b.id And a.activity_id = c.id And a.subtask_id = d.id And d.project_id = e.id And e.client_id = f.id And e.status = 'active' And a.employee_id = ". $_SESSION['login_user_id'] ." Group By a.subtask_id, a.activity_id, a.employee_id Order By client, project_name";
	// echo $sql;exit;
	$result = $conn->query($sql) or die('cannot write');
	$json_array = array();
	while($row = $result->fetch_assoc()){
		$json_array[] = $row;
	}
	return array('emp_mapped_projects'=> $json_array);
}

function fnGet($conn){
	//$empList = fnGetEmployees($conn);
	$empMappedProjList = fnGetEmpMappedProjectForEntry($conn);
	//$finalResMsg = json_encode(array_merge($empList, $empMappedProjList));
	$finalResMsg = json_encode($empMappedProjList);
	return  $finalResMsg;
}

function fnSaveTimeEntry($conn, $timeEntryArray){
	if(count($timeEntryArray) > 0){
		$sql_insert = "Insert Into timesheet.timeentry(subtask_id, activity_id, employee_id, entry_date, entry_hours, week_start) Values ";
		$sql_values = null;
		$sql_delete = null;
		$sql = null;
		$duplicateRows = '';
		foreach($timeEntryArray as $eachTime) {
			// if($duplicateRows !== $eachTime->subtask_id."~".$eachTime->activity_id."~".$eachTime->employee_id."~".$eachTime->week_start){
			if($duplicateRows === ''){
				$sql_delete = "Delete From timesheet.timeentry Where employee_id=".$eachTime->employee_id." And week_start='".$eachTime->week_start."'";
				$conn->query($sql_delete);
				$duplicateRows = 1;
			}
			$sql_values .= "(".$eachTime->subtask_id.",".$eachTime->activity_id.",".$eachTime->employee_id.",'".$eachTime->entry_date."',".$eachTime->entry_hours.",'".$eachTime->week_start."'),";
		}
		if($sql_values != null){
			$sql_values = rtrim($sql_values,',');
			$sql = $sql_insert . $sql_values;
			$conn->query($sql);
		}
	}
}

function fnPost($conn){
	$requestData = json_decode(file_get_contents('php://input'));
	fnSaveTimeEntry($conn, $requestData);
	$resMsg = fnGet($conn);
	echo $resMsg;
}

If($_SERVER['REQUEST_METHOD'] === 'GET'){
	$conn = fnGetConnection();
	$resMsg = fnGet($conn);
	mysqli_close($conn);
}

If($_SERVER['REQUEST_METHOD'] === 'POST'){
	header("Content-Type: application/json");
	$conn = fnGetConnection();
	fnPost($conn);
	mysqli_close($conn);
	exit();
}
?>

<html>
	<head>
                <link rel="shortcut icon" type="image/svg" href="../time_sheet.png">
		
		<link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">
		<link rel="stylesheet" href="../timesheet_v4.css">
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
		<title>Dvara Timesheet - Entry</title>
	</head>
	<body onload="fnPageLoadEntry()">
		<div id='client_div' style="width:99%; text-align: center;">
			<!-- <label for='ts__emplist'>Employee Name: </label> -->
			<span>Welcome <?php echo $_SESSION['login_user_name'] ?></span>
			<select id='ts__emplist' onchange='fnChangeEmpForTimeEntry(this)' style="display: none;">
				<option value="<?php echo $_SESSION['login_user_id'] ?>"><?php echo $_SESSION['login_user_name'] ?></option>
			</select>
			<label for='ts__weekselection'>Select Week: </label>
			<select id='ts__weekselection' onchange='fnDisplayMappedProjectOnSelectedDate(this)'>
			</select>
			<a href="../logout.php" style="padding-top: 8px; float: right;padding-left: 15px;">Logout</a>
			<?php if (isset($_SESSION['login_type'])) { ?>
			<a href="../admin/timesheet_admin.php" style="padding-top: 8px; float: right;">Admin</a>
			<?php } ?>
		</div>
		<br>
		<div id='search_filter' style="width:99%; background-color: white;">
			<input type="text" placeholder="Search Client, Project, Task etc.." id="filter_text" onkeyup="fnFilterProjects()" style="width:100%;">
		</div>
		<br>
		<div id='project_div_main' style="width:99%;">
			<div style="margin-top: 5px;">
				<span style="float: left;">Mapped Projects:</span>
				<input type="button" name="savetimeentry" value="Save" style="margin-left: 50px; float: right;" onclick="fnSaveTimeEntry()">
				<input type="button" name="expandAll" value="Expand All" style=" float: right;" onclick="expandAll()">
				<input type="button" name="collapseAll" value="Collapse All" style="margin-left: 50px; float: right;" onclick="collapseAll()">
			</div>
			<br/>
			<div id="project_total_div" style="text-align: center;">
					<label>Total: </label>
					<input type="text" name="timeentry_total" id="timeentry_total" class="readtOnly1" readonly>
				</div>
			<div id='project_div' style="display: none; text-align: center; margin-top: 10px;">
				<table id='mapped_project_tbl'>
					<thead>
					</thead>
					<tbody>
					</tbody>
				</table>
				<br>
				
			</div>
		</div>
		<br>
	</body>
</html>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script type="text/javascript" src="../timesheet_v4.js"></script>
<script type="text/javascript">
	var getResMsg = <?php echo json_encode($resMsg) ?>;
	//localStorage.setItem("ts_localstorage", getResMsg);
	localStorage.setItem("ts_entry_localstorage", getResMsg);
	//google.charts.load('current', {packages: ['corechart']});
	//google.charts.setOnLoadCallback(drawChart);

	
</script>
<script>
	$(document).ready(function(){
		$(document).on('click','.clientHeader',function(){
			$(this).nextUntil('tr.clientHeader').slideToggle(200);
		})
		
		$(document).on('keyup','#filter_text',function(){
			var val = $(this).val();
			if( val == "" || val == undefined){
				$('.clientProjects').hide();
			}
		})
	})

	function expandAll(){
		$('.clientProjects').show();
	}

	function collapseAll(){
		$('.clientProjects').hide();
	}
</script>
